// LinkItem.h: interface for the CLinkItem class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(_LINKITEM_H_)
#define _LINKITEM_H_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


#define DEFAULT_UNVISITED_COLOR  RGB(0, 0, 255)
#define DEFAULT_VISITED_COLOR    RGB(128,0,128)
#define DEFAULT_UNDERLINED       TRUE
#define DEFAULT_HOTSPOT_CURSOR   NULL

class CLinkItem : public CObject  
{
public:
	CLinkItem();
	virtual ~CLinkItem();

public:
	BOOL GetVisited() const { return m_bVisited; }
	void SetVisited(BOOL bVisited) { m_bVisited = bVisited; }
	
	CString GetUrl()const { return m_strUrl; }
	void SetUrl(CString strUrl) { m_strUrl = strUrl; }

	BOOL     GetUnderlinedLink()const {return m_bUnderlinedLink;}
	COLORREF GetLinkColor() const;
	COLORREF GetVisitedLinkColor() { return m_clrVisited;}
	HCURSOR	 GetCursor() const { return m_hCursorHotSpot;}


	void SetLinkProperties(COLORREF clrLink = DEFAULT_UNVISITED_COLOR, COLORREF clrVisited = DEFAULT_VISITED_COLOR, 
	HCURSOR hCursorHotSpot = DEFAULT_HOTSPOT_CURSOR, BOOL bUnderlinedLink = DEFAULT_UNDERLINED);

private:
	BOOL		m_bUnderlinedLink;
	COLORREF	m_clrLink, m_clrVisited;
	HCURSOR		m_hCursorHotSpot;
	BOOL        m_bVisited;
	CString     m_strUrl;
};

inline COLORREF CLinkItem::GetLinkColor() const
{
	if(m_bVisited)
	{
		return m_clrVisited;
	}
	else
	{
		return m_clrLink;
	}
}

#endif
