// ListCtrlLink.cpp : implementation file
//

#include "stdafx.h"
#include "ListCtrlLink.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CListCtrlLink

CListCtrlLink::CListCtrlLink()
{
	LOGFONT lf={0};
	HFONT hFont=(HFONT)GetStockObject(DEFAULT_GUI_FONT);
	::GetObject(hFont,sizeof(lf), &lf);
    lf.lfUnderline =TRUE;
    m_fontLink.CreateFontIndirect(&lf);
	lf.lfUnderline=FALSE;
	m_fontNoLink.CreateFontIndirect(&lf);

}

CListCtrlLink::~CListCtrlLink()
{
	POSITION pos;
	CString strKey;
	CLinkItem *pLinkItem;

	for (pos = m_linkMap.GetStartPosition(); pos != NULL; ) 
	{
		m_linkMap.GetNextAssoc( pos, strKey, (CObject*&)pLinkItem);
		if (pLinkItem) 
		{
			delete pLinkItem;
			pLinkItem = NULL;
		}
   }

   m_linkMap.RemoveAll();
}

BEGIN_MESSAGE_MAP(CListCtrlLink, CListCtrl)
	ON_NOTIFY_REFLECT(NM_CUSTOMDRAW, OnCustomDraw)
	ON_NOTIFY_REFLECT(NM_CLICK, &CListCtrlLink::OnNMClick)
END_MESSAGE_MAP()


void CListCtrlLink::OnCustomDraw(NMHDR* pNMHDR, LRESULT *pResult) {

	NMLVCUSTOMDRAW* pLVCD = reinterpret_cast<NMLVCUSTOMDRAW*>( pNMHDR );
	CLinkItem *pLink = NULL;
    *pResult = 0;

	switch (pLVCD->nmcd.dwDrawStage) 
	{

	case CDDS_PREPAINT:
		*pResult = CDRF_NOTIFYITEMDRAW;
		break;
	case CDDS_ITEMPREPAINT:
		*pResult = CDRF_NOTIFYSUBITEMDRAW;
		break;

	case CDDS_ITEMPREPAINT | CDDS_SUBITEM:
		pLink = GetLink(pLVCD->nmcd.dwItemSpec, pLVCD->iSubItem);
		if (pLink != NULL) 
		{
			pLVCD->clrText = pLink->GetLinkColor();
			if (pLink->GetUnderlinedLink()) 
			{
				::SelectObject(pLVCD->nmcd.hdc, m_fontLink.m_hObject);
			} 
			else 
			{
				::SelectObject(pLVCD->nmcd.hdc, m_fontNoLink.m_hObject);
			}
		}

		*pResult = CDRF_DODEFAULT;
		break;

	default:
			break;

	}

	if (pLVCD->nmcd.uItemState == CDIS_HOT) 
	{
		pLink = GetLink(pLVCD->nmcd.dwItemSpec,pLVCD->iSubItem);
		if (pLink != NULL) 
		{ 
			CListCtrl::SetHotCursor(pLink->GetCursor());
		}
	}
}


int CListCtrlLink::InsertItem(int nItem, LPCTSTR lpctszItem, LPCTSTR lpctszUrl) 
{
	CLinkItem *pLinkItem = NULL;
	int iRtn = -1;

	pLinkItem = new CLinkItem();
	if (pLinkItem == NULL) return -1; 

	iRtn = CListCtrl::InsertItem(nItem, lpctszItem);

	if (lpctszUrl && _tcslen(lpctszUrl) != 0) 
	{

		pLinkItem->SetUrl(lpctszUrl);

	} 
	else 
	{
		pLinkItem->SetLinkProperties(RGB(0,0,0),RGB(0,0,0),AfxGetApp()->LoadStandardCursor(IDC_ARROW),FALSE);
	}

	SetLink(nItem, 0, pLinkItem);

	return iRtn;
}

BOOL CListCtrlLink::SetItemText(int nItem, int nSubItem, LPCTSTR lpctszText,LPCTSTR lpctszUrl) 
{

	CLinkItem *pLinkItem = NULL;
	BOOL bRtn = FALSE;

	pLinkItem = new CLinkItem();
	if (pLinkItem == NULL) return FALSE;

	bRtn = CListCtrl::SetItemText(nItem, nSubItem, lpctszText);

	if (lpctszUrl && _tcslen(lpctszUrl) != 0) 
	{

		pLinkItem->SetUrl(lpctszUrl);

	} 
	else 
	{
		pLinkItem->SetLinkProperties(RGB(0,0,0),RGB(0,0,0),AfxGetApp()->LoadStandardCursor(IDC_ARROW),FALSE);
	}

	SetLink(nItem, nSubItem, pLinkItem);

	return bRtn;
}


void CListCtrlLink::PreSubclassWindow()
{
	CListCtrl::GetItemPosition(0, &m_pointOriginalPosition);
	unsigned long ulStyle = LVS_EX_ONECLICKACTIVATE|LVS_EX_FULLROWSELECT;
	CListCtrl::SetExtendedStyle(ulStyle);

	CListCtrl::PreSubclassWindow();
}


void CListCtrlLink::OnNMClick(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMITEMACTIVATE pNMItemActivate = reinterpret_cast<LPNMITEMACTIVATE>(pNMHDR);

	CLinkItem* pLink = NULL;
	CString strUrl;
	LRESULT result = TRUE;

	DWORD dwPos = GetMessagePos(); 
	CPoint point( LOWORD(dwPos), HIWORD(dwPos) ); 
	ScreenToClient(&point); 
	LVHITTESTINFO lvinfo; 
	lvinfo.pt = point; 
	lvinfo.flags = LVHT_ABOVE; 
    int nItem = SubItemHitTest(&lvinfo); 
	if(nItem != -1) 
    { 
	    pLink = GetLink(lvinfo.iItem ,lvinfo.iSubItem);

	    if (pLink != NULL) 
	    {
	  		strUrl = pLink->GetUrl();
			if (!strUrl.IsEmpty()) 
			{
				ShellExecute(NULL, NULL, strUrl, NULL, NULL, SW_SHOWNORMAL);
				pLink->SetVisited(TRUE);
			
			}
		}
	}

	*pResult = 0;
}

CLinkItem* CListCtrlLink::GetLink(int i, int j) 
{
	CString strLocation;
	strLocation.FormatMessage(_T("%1!d! x %2!d!"), i, j);
	return (CLinkItem*) m_linkMap[strLocation];
}

void CListCtrlLink::SetLink(int i, int j, CLinkItem* pItemLink) 
{
	CString strLocation;
	strLocation.FormatMessage(_T("%1!d! x %2!d!"), i, j);

	m_linkMap[strLocation] = (CObject*) pItemLink;
}


